﻿
class A {
	private int _x;

	public virtual int X {
		get {
			return _x;
		}
		set {
			_x = value;
		}
	}

	public virtual int Y { get; set; }

	public virtual int Z { get => 1; }
}

class B : A {
	public override int X {
		get => base.X;
		set {
			if (value <= 0) {
				throw new ArgumentOutOfRangeException(nameof(value), $"Only positive non-zero values allowed, but got {value}.");
			}
			base.X = value;
		}
	}

	public override int Y {
		set {
			if (value <= 0) {
				throw new ArgumentOutOfRangeException(nameof(value), $"Only positive non-zero values allowed, but got {value}.");
			}
			base.Y = value;
		}
	}

	public override int Z { get => 2; }	// Cannot add 'set' here
}

class Program {
	static void Main(string[] args) { 
		A a = new A();
		a.X = -1;
		a.Y = -2;
        Console.WriteLine($"{a.X} {a.Y}");

		a = new B();
		a.X = 10;
		a.Y = 20;
		Console.WriteLine($"{a.X} {a.Y}");
		a.X = -30;
    }
}