﻿namespace ParametricPropertiesAkaIndexers {

	class PositiveArray {
		private int[] array = new int[10];

		public int this[int index] {
			get => array[index];
			set {
				if (value <= 0) throw new ArgumentOutOfRangeException(nameof(value), "Must be positive value.");
				array[index] = value;
			}
		}

		// Would generate error at indexer declaration above:
		// Error: The type 'PositiveArray' already contains a definition for 'Item'
		// public int Item => array[0];
	}

	class A {
		public int Item => 5;

		[System.Runtime.CompilerServices.IndexerName("TenAdder")]
		public int this[int index] {
			get => index + 10;
		}
	}

	class B {
		// Error: not allowed
		// public static int this[int index] {
		//	  get => index + 10;
		// }
	}

	class Program {
		static void Main(string[] args) {
			PositiveArray arr = new PositiveArray();
			arr[0] = 5;
			Console.WriteLine(arr[1]);

			A a = new A();
			Console.WriteLine(a[5]);
		}
	}
}
